#define BUFSIZZ 512

// caseA: 512 works always, more causes an error SOMETIMES, see caseB.
// john refling.  caseA.c

/* OUTPUT, here we test 512 which works.

	open floppy, which is OK
	fno = 3, errno = 0 'No error'
	ie: fopen() OK

	try write() 512 which is OK
	RV = 0x200 or 512, errno = 0 'No error'

	Write OK!

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <err.h>
#include <sys/fcntl.h>

int main(int argc, char *argv[]) {

	char *buf = calloc(1, BUFSIZZ);

	printf("\nopen floppy, which is OK\n");
	int fno = open("/dev/floppy", O_RDWR, 0777);
	printf("fno = %d, errno = %d '%s'\n", fno, errno, strerror(errno));
	printf("ie: fopen() OK\n\n");

	// write some data to the floppy, when this fails,
	// it seems to put a "32 bit -1" in return value,
	// not a 64 bit -1 !!!

	printf("try write() 512 which is OK\n");
	errno = 0;
	ssize_t RV = write(fno, buf, BUFSIZZ);

	// print out the RV, it is a ssize_t, use %ld
	printf("RV = 0x%lx or %ld, errno = %d '%s'\n\nWrite OK!\n", (long unsigned)RV, RV, errno,
		strerror(errno));

	if (512 == RV) return(0);

	// see what constants RV matches:
	fprintf(stderr, "RV %s == 0\n", (RV == 0)?"IS":"IS NOT");
	fprintf(stderr, "RV %s < 0\n", (RV < 0)?"IS":"IS NOT");
	fprintf(stderr, "RV %s == -1\n", (RV == -1)?"IS":"IS NOT");
	fprintf(stderr, "RV %s == -1L\n", (RV == -1L)?"IS":"IS NOT");
	fprintf(stderr, "RV %s == -1U\n\n", (RV == -1U)?"IS":"IS NOT");

	return 0;
}
